#include <stdio.h>
#define MAXCOGNOME 25

struct persona
  {
  struct persona* prev;
  struct persona* next;
  int id; 
  char* cognome;
  int superiore;
  };

struct lista
  {
  struct persona* prima;
  struct persona* ultima;
  };

void append(struct lista* L, struct persona* p)
{
  if (L->prima==NULL)       
      L->prima=p;
  p->prev= L->ultima;       
  p->next=NULL;
  if (L->ultima!=NULL)
    L->ultima->next= p;     
  L->ultima= p;
}

int load(struct lista* L)
{
   int s;
   int c=0;
   char* cognome;
   int id;
   int superiore;
   struct persona* p;

   cognome= (char*)malloc(sizeof(char)*MAXCOGNOME+1);
   s=scanf("%d %d %s\n", &id, &superiore, cognome);

   while(s!=EOF)
     {
     p= (struct persona*)malloc( sizeof(struct persona) );
     p->cognome= cognome;
     p->id=id;
     p->superiore=superiore;
     append(L, p);
     c++;
     cognome= (char*)malloc(sizeof(char)*MAXCOGNOME+1); /* <<<< */
     s=scanf("%d %d %s\n", &id, &superiore, cognome);
     }
   return c;
}



int conta(struct lista* L, int id)
{
    struct persona* q;
    int c=0;
    for(q=L->prima; q!=NULL; q=q->next)
      if (q->id!=id)
	c++;
    return c;
}

void check_superiori(struct lista* L)
{
    struct persona* p;
    printf("checking superiori...\n");
    for(p=L->prima; p!=NULL; p=p->next)
      {
	int c;
	if (p->superiore!=0)
	    {
	    c= conta (L, p->superiore);
	    if (c!=1)
	      printf("Superiore non valido %d per %d %s\n", p->superiore, p->id, p->cognome);
	    }
      }
    printf("fatto.\n");
}

void check_idd(struct lista* L)
{
    struct persona* p;
    printf("checking id...\n");
    for(p=L->prima; p!=NULL; p=p->next)
      {
	int c;
	c= conta (L, p->id);
	if (c!=1)
	  printf("Id non valido: %d %s\n", p->id, p->cognome);
      }
    printf("fatto.\n");
}


void help_and_exit(char *s)
   {
       printf("Il comando %s fa una analisi dei file tipo tabella1.txt.\n"
	      "Tale tabella viene letta da standard input\n"
	      "0 - esegue il test degli id duplicati\n" 
	      "1 - esegue il test di esistenza dei superiori\n" 
	      "2 - esegue entrambi i test\n", 
	      s);
       exit(1);
   

int main(int argc, char** argv)
   {
   int c;
   struct lista L;
   L.prima=NULL;
   L.ultima=NULL;

   if (argc!=2)
     help_and_exit(argv[0]);

   if (argc==2 && 
       strcmp(argv[1], "0")!=0 &&
       strcmp(argv[1], "1")!=0 &&
       strcmp(argv[1], "2")!=0 
       )
     help_and_exit(argv[0]);

   c=load(&L);
   printf("caricati %d record\n",c );

   if (argc==2 && strcmp(argv[1], "0")==0 )
     check_superiori(&L);

   if (argc==2 && strcmp(argv[1], "1")==0 )
     check_id(&L);

   if (argc==2 && strcmp(argv[1], "2")==0 )
     {
     check_superiori(&L);
     check_id(&L);
     }

   return 0; 
   }
